﻿using System;

namespace PhoneApp.NavigateToView.Core.Views
{
    [AttributeUsage(AttributeTargets.Class | AttributeTargets.Interface, Inherited = false, AllowMultiple = false)]
    public sealed class ViewInfosAttribute : Attribute
    {
        private readonly Uri uriString;

        public ViewInfosAttribute(string uriString, UriKind uriKind = UriKind.Relative)
        {
            this.uriString = new Uri(uriString, uriKind);
        }

        public Uri Uri
        {
            get { return uriString; }
        }
    }
}